// Minimal art to get active with WSPR and a low cost NodeMCU (7 Euro) using WiFi timing
// DDS is low cost AD9850 Chinese board (3 Euro)
// Uses Arduino programming IDE
// WSPR_DATA is created with external program

// pinnen nu nog aansluiten DDS via SPI + inits hier en daar
// zou moeten werken

#include <NTPClient.h>
#include <ESP8266WiFi.h>
#include <WiFiUdp.h>
#include <AD9850SPI.h>

const char *ssid     = "";
const char *password = "";

const long utcOffsetInSeconds = 3600;

const int DDS_OSET = 100; // TX offset in band

// see WSPRgen, PA1W JO21 23
int WSPR_DATA[] =   {3,3,2,2,0,2,0,0,3,0,0,0,1,3,3,2,0,2,3,2,0,3,
                    0,3,1,1,1,2,0,0,0,2,2,2,3,2,2,1,2,1,0,0,2,2,
                    2,2,3,0,1,3,0,0,3,1,0,1,0,2,0,3,3,0,1,2,0,0,
                    0,3,3,2,1,0,3,2,3,0,1,0,2,3,0,0,3,0,3,1,0,2,
                    0,3,3,2,1,0,3,0,0,2,1,0,2,2,0,0,3,0,2,1,2,0,
                    1,3,1,2,3,3,2,0,3,1,2,3,2,2,2,3,1,3,2,2,0,0,
                    0,3,0,3,2,0,1,3,0,2,2,0,2,0,2,1,1,0,1,2,3,1,
                    2,0,2,1,1,0,2,0};

char daysOfTheWeek[7][12] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"}; 
int TX_time;
unsigned long WSPR_TXF = 0;
unsigned long WSPR_TX = 10.140100e6;  // this is the bottom of the band.
                                      // The station moves up with WSPR_TX+DDS_OSET) + random(0, 190) .
// Define NTP Client to get time
WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP, "pool.ntp.org", utcOffsetInSeconds);

void setup(){
  Serial.begin(115200);

  WiFi.begin(ssid, password);

  while ( WiFi.status() != WL_CONNECTED ) {
    delay ( 500 );
    Serial.print ( "." );
  }

  timeClient.begin();
}

// Set DDS frequency
void wsprTXtone(int t) { 
  if ((t >= 0) && (t <= 3) ) { 
        DDS.setfreq((WSPR_TXF + DDS_OSET) + (t * 1.4648), 0);
  }
}
 
// Data Tx function  
void wsprTX() { 
int i = 0; 
for (i=0;i<162;i++) { 
     wsprTXtone( WSPR_DATA[i] ); 
     delay(683); 
  } 
DDS.setfreq(0,0);
}

void WSPR_TX_start(){
  Serial.print("Start WSPR transmission, minutes => ");
  Serial.println(TX_time);
  wsprTX();
  delay(60000); // one minute delay
}

void loop() {
  timeClient.update();
  TX_time=timeClient.getMinutes();

  if(TX_time % 4 == 0) //transmission each 4 minutes
  { 
    WSPR_TX_start();
  }
    else {
        //Serial.print("+");
        /*Serial.print(daysOfTheWeek[timeClient.getDay()]);
        Serial.print(", ");
        Serial.print(timeClient.getHours());
        Serial.print(":");
        Serial.print(timeClient.getMinutes());      
        Serial.print(":");
        Serial.println(timeClient.getSeconds());*/
    }
  //Serial.println(timeClient.getFormattedTime());
  delay(100);
}
